
function echo(message)
	Turbine.Shell.WriteLine(message);
end

function round(what, precision)
   return math.floor(what*math.pow(10,precision)+0.5) / math.pow(10,precision)
end

function rgb(num)
	return round(num/255,2);
end

function fill(text, pattern, length)
	if string.len(text)<length then
		text = string.rep(pattern, length-string.len(text)) .. text;
	end
	return text;
end

function debug(message)
	if debugMode then
		local getdate = Turbine.Engine.GetDate();
		message = fill(getdate.Hour,"0",2) ..":".. fill(getdate.Minute,"0",2) ..":".. fill(getdate.Second,"0",2) .." ".. message;
		Turbine.Shell.WriteLine(message);
		Turbine.Engine.ScriptLog(debugPluginName .."|".. message);
	end
end

function Dump(o)	
   if type(o) == 'table' then		
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. Dump(v) .. ','
      end
      return s .. '} '
   else		
      return tostring(o)
   end
end

