import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Gillothrin.Items.GUI";
import "Gillothrin.Items.WalletOptionItem";
import "Gillothrin.Items.BaseFunc";

OptionsControl = class(Turbine.UI.Control());
function OptionsControl:Constructor(optionsObj,wallet)
	Turbine.UI.Control.Constructor(self);
	self.optionsWidth = 400;
	self.optionsHeight = 400;
	self.optionsObj = optionsObj;
	self.wallet = wallet;
	self:SetHeight(self.optionsHeight);
	self:SetWidth(self.optionsWidth);

	self.checkAllBoxControl = Turbine.UI.Control();
	self.checkAllBoxControl:SetParent(self);
	self.checkAllBoxControl:SetPosition(0,0);
	self.checkBox = VCheckBox(false,0,0,self.optionsWidth,20);
	self.checkBox:SetParent(self.checkAllBoxControl);
	self.checkBox:SetText("All");
	
	self.listBox = Turbine.UI.ListBox();
	self.listBox:SetParent(self);
	self.listBox:SetBackColor( Turbine.UI.Color(rgb(0),rgb(0),rgb(0)) );
    self.listBox:SetPosition( 0, 20 );
    self.listBox:SetSize( self.optionsWidth, self.optionsHeight-100);
	
	local this = self;
	self.CheckAllBoxes = function(s,a)
		for i=1,this.listBox:GetItemCount() do
			local item = this.listBox:GetItem(i);
			item.checkBox:SetChecked(s:IsChecked());
		end
	end
	
	AddCallback(self.checkBox,"CheckedChanged",self.CheckAllBoxes);

	
	self.optionsCancelButton = VButton("Cancel",200,20,100,20);
	self.optionsCancelButton:SetParent(self);
	
	self.OptionsCancel = function(s,a)
		this:RepaintOptionsControl();
	end
	AddCallback(self.optionsCancelButton,"Click",self.OptionsCancel);
	
	self.optionsSaveButton = VButton("Save",50,20,100,20);
	self.optionsSaveButton:SetParent(self);

	self.OptionSave = function(s,a)
		local uncheckedElements = {};
		for i=1,this.listBox:GetItemCount() do
			local item = this.listBox:GetItem(i);
			if (not item.checkBox:IsChecked()) then
				uncheckedElements[item.name] = true;
			end
		end
		this.optionsObj.notSelectedItems = uncheckedElements;
		this.optionsObj:SaveData();
		_G.eventWalletChange(this,this.optionsObj);-- yak!
	end
	AddCallback(self.optionsSaveButton,"Click",self.OptionSave);
end

function OptionsControl:RepaintOptionsControl()
	local rowHeight = 20;
	local foundItems = self.wallet:GetFoundItems();
	local height = self.wallet.size*rowHeight;
	local maxCheckBoxWidth = self.listBox:GetWidth();
	self.listBox:ClearItems();
	
	self:SetSize(self.optionsWidth,height+100);
	self.listBox:SetHeight(height);
	
	for k,v in pairs(foundItems) do
		if(self.optionsObj.notSelectedItems[k]) then
			self.listBox:AddItem(WalletOptionItem(v,maxCheckBoxWidth,false,rowHeight));
		else
			self.listBox:AddItem(WalletOptionItem(v,maxCheckBoxWidth,true,rowHeight));
		end
	end
	
	self.listBox:Sort(function(a,b) return a.name < b.name end);
	self.optionsSaveButton:SetTop(self:GetHeight()-80);
	self.optionsCancelButton:SetTop(self:GetHeight()-80);
end

function OptionsControl:ShowOptionsControl()
	self:RepaintOptionsControl();
	self:SetVisible(true);
	Turbine.PluginManager.ShowOptions(Plugins[pluginName]);
end

function OptionsControl:Unload()
	RemoveCallback(self.optionsSaveButton,"Click",self.OptionSave);
	RemoveCallback(self.optionsCancelButton,"Click",self.OptionsCancel);
	RemoveCallback(self.checkBox,"CheckedChanged",self.CheckAllBoxes);
end
