import "Turbine.UI";
import "Gillothrin.Items.GUI";

TooltipWindow = class(Turbine.UI.Window);

function TooltipWindow:Constructor(control, text)
    Turbine.UI.Window.Constructor(self);
    self:SetMouseVisible(false);
    self:SetVisible(false);
    self:SetZOrder(10);
    local bgc = Turbine.UI.Color(0.6,rgb(0),rgb(0),rgb(0));
	
    self.center = Turbine.UI.Control();
    self.center:SetParent(self);
    self.center:SetBackColor(bgc);

    self.label = Turbine.UI.Label();
    self.label:SetParent(self);
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
    self.label:SetBackColor(bgc);
	
    if (text ~= nil) then
        self:SetText(text);
    end
    if (control ~= nil) then
        self:SetControl(control);
    end
	local strlen = string.len(text);
	self:SetSize(strlen*7+20,16+3);
end

function TooltipWindow:SetText(text)
    self.label:SetText(text);
end

function TooltipWindow:SetControl(control)
    self.control = control;
    AddCallback(self.control, "MouseHover", function(sender, args)
        if (self:IsVisible()) then
            return;
        end
        local x, y = Turbine.UI.Display.GetMousePosition();
        x, y = ValidatePosition(x + 8, y + 8, self:GetSize());
        self:SetPosition(x, y);
        self:SetVisible(true);
    end);
    
    AddCallback(self.control, "MouseLeave", function(sender, args)
        self:SetVisible(false);
    end);
end

function TooltipWindow:SetSize(width, height)
    width = math.max(width, 38);
    height = math.max(height, 22);
	
    self.center:SetPosition(3, 3);
    self.label:SetPosition(7, 3);
    self.center:SetSize(width - 6, height - 6);
    self.label:SetSize(width - 14, height - 6);
    Turbine.UI.Window.SetSize(self, width, height);
end

