import "Gillothrin.Items.VindarPatch";

Wallet = class(Turbine.Object);
function Wallet:Constructor(wallet,optionsObj)
	Turbine.Object.Constructor( self );
	self.optionsObj = optionsObj;
	self.playerWallet = wallet;
	self.items = {};
	self:LoadWallet();
end

function Wallet:GetFoundItems()
	return self.items;
end

function Wallet:GetLOTROWallet()
	return self.playerWallet;
end

function Wallet:LoadWallet()	
	local walletSize = self.playerWallet:GetSize();
	self.size = walletSize;
	self.items = {};
	for f=1, walletSize do
		local walletItem = self.playerWallet:GetItem(f);
		local name = walletItem:GetName();
		local ico = walletItem:GetSmallImage();
		self.optionsObj.seenWalletItems[name] = ico;
		self.items[name]= VWalletItem(name, ico, walletItem);	
	end
	
	for k,v in pairs(self.optionsObj.seenWalletItems) do		
		if self.items[k] == nil then
			self.items[k] = VWalletItem(k,v,nil);
		end
	end
end	

VWalletItem = class(Turbine.Object);
function VWalletItem:Constructor(name,ico,walletItem)
	Turbine.Object.Constructor(self);
	self.name = name;
	self.ico = ico;
	self.walletItem = walletItem;
end

function VWalletItem:GetName()
	return self.name;
end

function VWalletItem:GetQuantity()
	if(self.walletItem ~= nil) then
		return self.walletItem:GetQuantity();
	end
	return 0;
end

function VWalletItem:GetSmallImage()
	return self.ico;
end

function VWalletItem:Listen(f)
	if self.walletItem ~= nil then
		self.listener = f;
		AddCallback(self.walletItem,"QuantityChanged",f);
	end
end

function VWalletItem:Unhook()
	if self.walletItem ~= nil then
		RemoveCallback(self.walletItem,"QuantityChanged",self.listener);
	end
end
